#ifndef MYASSERT_H
#define MYASSERT_H

#undef  assert

#ifdef  NDEBUG

#define assert(exp)     ((void)0)

#else

#ifdef  __cplusplus
extern "C" {
#endif

void myassertfail(const char *, const char *, unsigned);

#ifdef  __cplusplus
}
#endif

#define assert(exp) (void)( (exp) || (myassertfail(#exp, __FILE__, __LINE__), 0) )

#endif  /* NDEBUG */

#endif
